#pragma once
#include "../pteidlib/pteidlib.h"

using namespace System;

namespace eidpt 
{	
  	public enum class PteidAddressChangeState 
	{
		INITIALISING		= ADDR_INITIALISING,		// Initialising
		CONNECTING			= ADDR_CONNECTING,          // Connecting to the Server (PIN is asked)
		READING_INFO		= ADDR_READING_INFO,        // Reading info (DH params, ...) from the card
		SENDING_INFO		= ADDR_SENDING_INFO,        // Sending info to the server
		INIT_SEC_CHANNEL	= ADDR_INIT_SEC_CHANNEL,    // Initialising the secure channel (DH)
		SERVER_CHALL		= ADDR_SERVER_CHALL,        // Send challenge to the server
		SERVER_AUTH			= ADDR_SERVER_AUTH,         // Let the card authenticate the server
		CLIENT_AUTH			= ADDR_CLIENT_AUTH,         // Let the server authenticate the card
		SERVER_AUTH2		= ADDR_SERVER_AUTH2,        // Second authentication of the server (Role Auth.)
		WRITE				= ADDR_WRITE,               // Write the new Address and SOD to the card
		FINISH				= ADDR_FINISH,              // Finish the address update (send responses to the server)
		FINISHED			= ADDR_FINISHED,            // The Change Address flow has completed.
		CANCELLED			= ADDR_CANCELLED		    // The Change Address flow was cancelled.
	};

    // class mimicking PTEID_ADDR
    public ref class PteidAddr
    {
    public: 
        PteidAddr(const PTEID_ADDR& i);
        PTEID_ADDR ToUnmanaged();

		short version;
		String^ addrType;
		String^ country;
		String^ district;
		String^ districtDesc;
		String^ municipality;
		String^ municipalityDesc;
		String^ freguesia;
		String^ freguesiaDesc;
		String^ streettypeAbbr;
		String^ streettype;
		String^ street;
		String^ buildingAbbr;
		String^ building;
		String^ door;
		String^ floor;
		String^ side;
		String^ place;
		String^ locality;
		String^ cp4;
		String^ cp3;
		String^ postal;
		String^ numMor;
		String^ countryDescF;
		String^ addressF;
		String^ cityF;
		String^ regioF;
		String^ localityF;
		String^ postalF;
		String^ numMorF;
    };
}
